Redmine - Feature #421

Impersonate user feature
2007-09-01 08:08 - Marc Champion

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Resolution:

Description

| really like the "impersonation” feature in project/open where an admin can impersonate other users in order
to test their environment. In redmine | have
to keep a list with user's passwords and forbid them to change it.

Related issues:

Related to Redmine - Feature #18609: Elevate to admin mode for authorized use... New

Has duplicate Redmine - Feature #12119: Add a "View as ..." feature for admin... Closed

Has duplicate Redmine - Feature #7693: "Log In As" for Admins Closed 2011-02-23
History

#1 - 2011-05-19 21:39 - Cassiano Monteiro

+1!

This is very useful when you have lots of people with different permissions using Redmine. Every time someone can’t do something, | have to go
there and ask him to show me, so | can figure out what permission is missing.

#2 - 2012-03-07 17:05 - Anonymous
+1!
That would be really helpful when adding and defining new roles like a product manager.

A work-around would be having a special test user with internal authentication and assigning him to different roles. But if you need to test different
users with different rights - as mentioned above - this approach is falling short.

#3 - 2012-06-07 03:41 - William Conley
+1

| recently built this feature for an OSCommerce installation and find it Very Useful. Eventually I'll build it for Redmine (I was here checking to see if
redmine has it already ...). It would be very cool if someone built it ... first.

#4 - 2012-07-30 16:35 - Jan Niggemann (redmine.org team member)

Hi William, any progress on this? It would be really cool...

#5 - 2012-07-30 16:57 - William Conley

Nope. No time as yet. But I've needed it a couple times. Had to settle for "assigning" the Issue to the person in question instead of "creating the issue"
in their login for them. For now.

The OSCommerce one took only a few hours to perfect, but | have not begun this one. Yet.
Last thing | built (needed!!) was a daily email showing all issues that were "out of line"

It shows items beyond due date. Also beyond our service level (# of days based on start date and tracker). It checks the selected tracker and our
present response time for that tracker, which is renamed service level, and compares to see if it is "beyond" the response time. Lists those beyond.

We also modified "Priority" to which we've added "HOLD" and "Question for client" (the daily email ignores these two priorities, since we are waiting
for the client and have nothing to do).

Sectioned by Tracker, then sorted by Priority and Start date (descending, of course), we now have a daily email to tell me who is and isn't keeping up

with their workload. And whether our Approx Response Times require adjustment! (Eventually, it'll just be calculated instead and adjusted by this daily
process, but that's down the road!)
#6 - 2012-07-30 17:32 - Jan Niggemann (redmine.org team member)

William Conley wrote:

Nope. No time as yet. But I've needed it a couple times.

Dang, just today I'd have needed this a couple of times...

The OSCommerce one took only a few hours to perfect, but | have not begun this one. Yet.

I'm not fluent in Ruby / RoR, otherwise | could have contributed.

Last thing | built (needed!!) was a daily email showing all issues that were "out of line"

Isn't there a rake task for this?
Sectioned by Tracker, then sorted by Priority and Start date (descending, of course), we now have a daily email to tell me who is and isn't

keeping up with their workload. And whether our Approx Response Times require adjustment! (Eventually, it'll just be calculated instead and
adjusted by this daily process, but that's down the road!)

OK, that's more than the default rake task does...

#7 - 2015-01-15 20:05 - Moritz Koehler

Here is a Plugin that works for me.
| use Redmine 2.6.

https://github.com/leonko/redmine_pretend

#8 - 2015-01-27 22:14 - James H

The easiest thing for me was:

Make "NPC" users (i named them according to their respective position or role) and have the same SUPER SIMPLE password for all of them (i also
changed the password rules to accomodate for an even simpler password before changing the rules back).

Make changes as an admin. If i need to test a feature and | need to see the view as a certain role... | log in as that role/user and do what | need. Log
back in as admin to make more changes. etc.

| also have these members set up in a project like real users might be set up in a real project. This helps me to create an analogous environment to
test similar situations and try to reproduce issues.

This is almost as easy as using some sort of "impersonate" feature, and to me, it is more definitive flexible and error-free (from a data standpoint).
| would advise against logging into other actual users' accounts for testing... but i guess you do with what you have
#9 - 2015-01-27 22:37 - William Conley
James H wrote:
The easiest thing for me was:
Make "NPC" users ...
In my case this is not helpful as we don't always want this as a "fake" user, sometimes we want it as a real user. For instance: | have a client who
likes to pay with Paypal outside our commerce system. So | have to log in to the system and enter a payment as that client as if he made the payment
by check, and then log out as the client and log in as Admin and record the arrival of the money.

Unusual circumstances like this will always occur. So we have an Impersonate button in the accounting system to allow me to override the system
and log in as that specific user.

It's also helpful for walking through a purchase with a client and validating what they see in our systems. You can't really tell a client to click on the
bottom link they see if you can't see the same list they are seeing.

#10 - 2015-03-09 07:02 - Toshi MARUYAMA

- Related to Feature #18609: Elevate to admin mode for authorized user instead of always working at admin level added

#11 - 2016-12-24 09:39 - Go MAEDA
- Has duplicate Feature #7693: "Log In As" for Admins added
https://github.com/leonko/redmine_pretend

#12 - 2017-03-10 13:53 - Anonymous

+1

This would be a very useful feature!
